package com.ejie.ad74a.service;

import java.io.IOException;
import java.io.OutputStream;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.CreationHelper;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.odftoolkit.odfdom.doc.OdfSpreadsheetDocument;
import org.odftoolkit.odfdom.doc.table.OdfTable;
import org.odftoolkit.odfdom.doc.table.OdfTableRow;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ad74a.dao.TramitesExpedienteDao;
import com.ejie.ad74a.model.Documento;
import com.ejie.ad74a.model.DocumentosTarea;
import com.ejie.ad74a.model.Expedientes;
import com.ejie.ad74a.model.TareasTramite;
import com.ejie.ad74a.model.TramitesExpediente;
import com.ejie.ad74a.service.documentos.DocumentosService;
import com.ejie.ad74a.util.constantes.Constantes;
import com.ejie.ad74a.util.constantes.EstadoDocuEnum;
import com.ejie.ad74a.util.constantes.EstadoTareasEnum;
import com.ejie.ad74a.ws.client.platea.service.PlateaService;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;
import com.lowagie.text.Document;
import com.lowagie.text.Phrase;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfWriter;

/**
 * TramitesExpedienteServiceImpl generated by UDA, 22-mar-2023 17:10:15.
 * 
 * @author UDA
 */

@Service(value = "tramitesExpedienteService")
public class TramitesExpedienteServiceImpl implements TramitesExpedienteService {

	private static final Logger logger = LoggerFactory.getLogger(TramitesExpedienteServiceImpl.class);

	@Autowired
	private TramitesExpedienteDao tramitesExpedienteDao;

	@Autowired
	private PlateaService plateaService;

	@Autowired
	private DocumentosTareaService documentosTareaService;

	@Autowired
	private DocumentosService documentosService;

	/**
	 * Inserts a single row in the TramitesExpediente table.
	 *
	 * @param tramitesExpediente TramitesExpediente
	 * @return TramitesExpediente
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TramitesExpediente add(TramitesExpediente tramitesExpediente) {
		return this.tramitesExpedienteDao.add(tramitesExpediente);
	}

	/**
	 * Updates a single row in the TramitesExpediente table.
	 *
	 * @param tramitesExpediente TramitesExpediente
	 * @return TramitesExpediente
	 */
	@Transactional(rollbackFor = Throwable.class)
	public TramitesExpediente update(TramitesExpediente tramitesExpediente) {
		return this.tramitesExpedienteDao.update(tramitesExpediente);
	}

	/**
	 * Finds a single row in the TramitesExpediente table.
	 *
	 * @param tramitesExpediente TramitesExpediente
	 * @return TramitesExpediente
	 */
	public TramitesExpediente find(TramitesExpediente tramitesExpediente) {
		return (TramitesExpediente) this.tramitesExpedienteDao.find(tramitesExpediente);
	}

	public TramitesExpediente findTramiteByTaskGUID(TramitesExpediente tramitesExpediente) {
		return (TramitesExpediente) this.tramitesExpedienteDao.findTramiteByTaskGUID(tramitesExpediente);
	}

	/**
	 * Deletes a single row in the TramitesExpediente table.
	 *
	 * @param tramitesExpediente TramitesExpediente
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(TramitesExpediente tramitesExpediente) {
		this.tramitesExpedienteDao.remove(tramitesExpediente);
	}

	/**
	 * Finds a list of rows in the TramitesExpediente table.
	 *
	 * @param tramitesExpediente TramitesExpediente
	 * @param tableRequestDto    TableRequestDto
	 * @return List<TramitesExpediente>
	 */
	public List<TramitesExpediente> findAll(TramitesExpediente tramitesExpediente, TableRequestDto tableRequestDto) {
		return (List<TramitesExpediente>) this.tramitesExpedienteDao.findAll(tramitesExpediente, tableRequestDto);
	}

	/**
	 * Finds rows in the TramitesExpediente table using like.
	 *
	 * @param tramitesExpediente TramitesExpediente
	 * @param tableRequestDto    TableRequestDto
	 * @param startsWith         Boolean
	 * @return List<TramitesExpediente>
	 */
	public List<TramitesExpediente> findAllLike(TramitesExpediente tramitesExpediente, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return (List<TramitesExpediente>) this.tramitesExpedienteDao.findAllLike(tramitesExpediente, tableRequestDto,
				startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Removes rows from the TramitesExpediente table.
	 *
	 * @param tableRequestDto TableRequestDto
	 */
	public void removeMultiple(TableRequestDto tableRequestDto) {
		this.tramitesExpedienteDao.removeMultiple(tableRequestDto);
	}

	/**
	 * Filter method in the TramitesExpediente table.
	 *
	 * @param filterTramitesExpediente TramitesExpediente
	 * @param tableRequestDto          TableRequestDto
	 * @param startsWith               Boolean
	 * @return TableResponseDto<TramitesExpediente>
	 */
	public TableResponseDto<TramitesExpediente> filter(TramitesExpediente filterTramitesExpediente,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<TramitesExpediente> listaTramitesExpediente = this.tramitesExpedienteDao
				.findAllLike(filterTramitesExpediente, tableRequestDto, false);
		Long recordNum = this.tramitesExpedienteDao.findAllLikeCount(
				filterTramitesExpediente != null ? filterTramitesExpediente : new TramitesExpediente(), false);

		TableResponseDto<TramitesExpediente> tableResponseDto = new TableResponseDto<TramitesExpediente>(
				tableRequestDto, recordNum, listaTramitesExpediente);

		if (tableRequestDto.getMultiselection().getSelectedIds() != null) {
			List<TableRowDto<TramitesExpediente>> reorderSelection = this.tramitesExpedienteDao
					.reorderSelection(filterTramitesExpediente, tableRequestDto, startsWith);
			tableResponseDto.setReorderedSelection(reorderSelection);
			tableResponseDto.addAdditionalParam("reorderedSelection", reorderSelection);
			tableResponseDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds() != null) {
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List<TableRowDto<TramitesExpediente>> reorderSeeker = this.tramitesExpedienteDao
					.reorderSelection(filterTramitesExpediente, tableRequestDto, startsWith);
			tableResponseDto.setReorderedSeeker(reorderSeeker);
			tableResponseDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return tableResponseDto;
	}

	/**
	 * Searches rows in the TramitesExpediente table.
	 *
	 * @param filterTramitesExpediente TramitesExpediente
	 * @param searchTramitesExpediente TramitesExpediente
	 * @param tableRequestDto          TableRequestDto
	 * @param startsWith               Boolean
	 * @return List<TableRowDto<TramitesExpediente>>
	 */
	public List<TableRowDto<TramitesExpediente>> search(TramitesExpediente filterTramitesExpediente,
			TramitesExpediente searchTramitesExpediente, TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.tramitesExpedienteDao.search(filterTramitesExpediente, searchTramitesExpediente, tableRequestDto,
				startsWith);
	}

	/**
	 * Reorder the selection made in TramitesExpediente table.
	 *
	 * @param filterTramitesExpediente TramitesExpediente
	 * @param tableRequestDto          TableRequestDto
	 * @param startsWith               Boolean
	 * @return Object
	 */
	public Object reorderSelection(TramitesExpediente filterTramitesExpediente, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		return this.tramitesExpedienteDao.reorderSelection(filterTramitesExpediente, tableRequestDto, startsWith);
	}

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Finder method in the hierarchical the TramitesExpediente table.
	 *
	 * @param filterTramitesExpediente TramitesExpediente
	 * @param tableRequestDto          TableRequestDto
	 * @param startsWith               Boolean
	 * @return TableResponseDto<JerarquiaDto<TramitesExpediente>>
	 */
	public TableResponseDto<JerarquiaDto<TramitesExpediente>> jerarquia(TramitesExpediente filterTramitesExpediente,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		List<JerarquiaDto<TramitesExpediente>> listaTramitesExpediente = this.tramitesExpedienteDao
				.findAllLikeJerarquia(filterTramitesExpediente, tableRequestDto);
		Long recordNum = this.tramitesExpedienteDao.findAllLikeCountJerarquia(filterTramitesExpediente,
				tableRequestDto);
		return new TableResponseDto<JerarquiaDto<TramitesExpediente>>(tableRequestDto, recordNum,
				listaTramitesExpediente);
	}

	/**
	 * Finder method for siblings rows in the hierarchical the TramitesExpediente
	 * table.
	 *
	 * @param filterTramitesExpediente TramitesExpediente
	 * @param tableRequestDto          TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<TramitesExpediente>>
	 */
	public TableResponseDto<JerarquiaDto<TramitesExpediente>> jerarquiaChildren(
			TramitesExpediente filterTramitesExpediente, TableRequestDto tableRequestDto) {
		TableResponseDto<JerarquiaDto<TramitesExpediente>> tableResponseDto = new TableResponseDto<JerarquiaDto<TramitesExpediente>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN,
				this.tramitesExpedienteDao.findAllChild(filterTramitesExpediente, tableRequestDto));
		return tableResponseDto;
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<TramitesExpediente> getMultiple(TramitesExpediente filterTramitesExpediente,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		return this.tramitesExpedienteDao.getMultiple(filterTramitesExpediente, tableRequestDto, startsWith);
	}

	/**
	 * Devuelve un fichero en el formato deseado que contiene los datos exportados
	 * de la tabla.
	 *
	 * @param filterTramitesExpediente TramitesExpediente
	 * @param columns                  String[]
	 * @param fileName                 String
	 * @param sheetTitle               String
	 * @param reportsParams            ArrayList<?>
	 * @param tableRequestDto          TableRequestDto
	 * @param request                  HttpServletRequest
	 * @param response                 HttpServletResponse
	 */
	@Override
	public void generateReport(TramitesExpediente filterTramitesExpediente, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		// Accede a la DB para recuperar datos
		List<TramitesExpediente> filteredData = getDataForReports(filterTramitesExpediente, tableRequestDto);
		String extension = null;

		// Comprobar si las siguientes variables estan vacias, en caso de estarlo se las
		// asigna un valor generico
		fileName = (fileName != null && !fileName.isEmpty()) ? fileName : "report";
		sheetTitle = (sheetTitle != null && !sheetTitle.isEmpty()) ? sheetTitle
				: TramitesExpediente.class.getSimpleName();

		// Obtener el formato de fecha especifico del locale
		SimpleDateFormat formatter = DateTimeManager.getDateTimeFormat(request.getLocale());

		// Cuando no se definen columnas porque se quieren obtener todas
		if (columns == null) {
			Field[] fields = TramitesExpediente.class.getDeclaredFields();
			ArrayList<String> tempColumns = new ArrayList<String>();

			for (int i = 0; i < fields.length; i++) {
				try {
					String methodName = fields[i].getName();
					methodName = methodName.substring(0, 1).toUpperCase() + methodName.substring(1);
					TramitesExpediente.class.getMethod("get" + methodName);
					tempColumns.add(fields[i].getName());
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				}

			}
			columns = tempColumns.toArray(new String[0]);
		}

		// si no se definen el nombre de las columnas , se dejan las de por defecto.
		if (columnsName == null) {
			columnsName = columns;
		}

		String servletPath = request.getServletPath();
		String reportType = null;
		if (servletPath.contains("/") && (servletPath.lastIndexOf("/") + 1 != servletPath.length())) {
			reportType = servletPath.substring(servletPath.lastIndexOf("/") + 1, servletPath.length());
		} else {
			reportType = servletPath.substring(0, servletPath.length());
		}

		if (reportType.equals("xlsReport")) {
			extension = ".xls";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("xlsxReport")) {
			extension = ".xlsx";
			generateExcelReport(filteredData, columns, columnsName, fileName, sheetTitle, extension, formatter,
					response);
		} else if (reportType.equals("pdfReport")) {
			extension = ".pdf";
			generatePDFReport(filteredData, columns, columnsName, fileName, response);
		} else if (reportType.equals("odsReport")) {
			extension = ".ods";
			generateODSReport(filteredData, columns, columnsName, fileName, sheetTitle, response);
		} else if (reportType.equals("csvReport")) {
			extension = ".csv";
			// Obtener idioma
			String language = request.getLocale().getLanguage();
			generateCSVReport(filteredData, columns, columnsName, fileName, sheetTitle, language, response);
		}

	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<TramitesExpediente>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param extension    String
	 * @param formatter    SimpleDateFormat
	 * @param response     HttpServletResponse
	 */
	private void generateExcelReport(List<TramitesExpediente> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String extension, SimpleDateFormat formatter,
			HttpServletResponse response) {
		try {
			// Creacion del Excel
			Workbook workbook = null;
			if (extension == ".xlsx") {
				workbook = new XSSFWorkbook();
				response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
			} else {
				workbook = new HSSFWorkbook();
				response.setContentType("application/vnd.ms-excel");
			}

			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + extension + "");

			// Creacion de una hoja y asignacion de su nombre
			Sheet sheet = workbook.createSheet(sheetTitle);

			// Se crea una fuente para estilizar las cabeceras
			Font headerFont = workbook.createFont();
			headerFont.setBold(true);
			headerFont.setFontHeightInPoints((short) 12);

			// Se crea un CellStyle con la fuente
			CellStyle headerCellStyle = workbook.createCellStyle();
			headerCellStyle.setAlignment(HorizontalAlignment.CENTER);
			headerCellStyle.setFont(headerFont);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Se crea la fila para insertar los titulos de las columnas
			Row row = sheet.createRow(rowNumber++);

			// Añadir titulos
			for (int i = 0; i < columnsName.length; i++) {
				Cell cell = row.createCell(i);
				cell.setCellValue(columnsName[i]);
				cell.setCellStyle(headerCellStyle);
			}

			// CreationHelper ayudara a mantener la compatibilidad del DataFormat tanto si
			// se crea un .xls como un .xlsx
			CreationHelper createHelper = workbook.getCreationHelper();

			// Se crea un CellStyle para añadir el formateador de fechas
			CellStyle dateCellStyle = workbook.createCellStyle();
			dateCellStyle.setDataFormat(createHelper.createDataFormat().getFormat(formatter.toPattern()));

			// Añadir datos
			for (TramitesExpediente rowTramitesExpediente : filteredData) {
				int cellNumber = 0;
				row = sheet.createRow(rowNumber++);

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					Cell cellTramitesExpediente = row.createCell(cellNumber++);
					cellTramitesExpediente.setCellValue(getCellValue(column, rowTramitesExpediente));
				}
			}

			// Se adapta el ancho de las columnas al contenido
			for (int i = 0; i < columns.length; i++) {
				sheet.autoSizeColumn(i);
			}

			// Se añade el fichero excel al response
			workbook.write(response.getOutputStream());
			workbook.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<TramitesExpediente>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param response     HttpServletResponse
	 */
	private void generatePDFReport(List<TramitesExpediente> filteredData, String[] columns, String[] columnsName,
			String fileName, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".pdf");
			response.setContentType("application/pdf");

			Document document = new Document();
			// Se añade el fichero pdf al response
			PdfWriter.getInstance(document, response.getOutputStream());

			document.open();

			PdfPTable table = new PdfPTable(columns.length);

			for (String column : columnsName) {
				PdfPCell header = new PdfPCell();
				header.setBorderWidth(2);
				header.setPhrase(new Phrase(column));
				table.addCell(header);
			}

			// Añadir datos
			for (TramitesExpediente rowTramitesExpediente : filteredData) {
				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					table.addCell(getCellValue(column, rowTramitesExpediente));
				}
			}

			document.add(table);
			document.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<TramitesExpediente>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param response     HttpServletResponse
	 */
	private void generateODSReport(List<TramitesExpediente> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, HttpServletResponse response) {
		try {
			// Se añade el fichero ods al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".ods");
			response.setContentType("application/vnd.oasis.opendocument.spreadsheet");

			OdfSpreadsheetDocument ods = OdfSpreadsheetDocument.newSpreadsheetDocument();
			ods.getOrCreateDocumentStyles();

			// Hay que eliminar la hoja que se genera por defecto
			ods.getTableByName("Sheet1").remove();

			// Hoja nueva
			OdfTable table = OdfTable.newTable(ods, filteredData.size() + 1, columns.length);
			table.setTableName(sheetTitle);

			// Inicializar contador de filas
			int rowNumber = 0;

			// Cabeceras
			OdfTableRow row = table.getRowByIndex(rowNumber++);
			for (int i = 0; i < columnsName.length; i++) {
				row.getCellByIndex(i).setStringValue(columnsName[i]);
			}

			// Añadir datos
			for (TramitesExpediente rowTramitesExpediente : filteredData) {
				row = table.getRowByIndex(rowNumber++);
				int cellNumber = 0;

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					row.getCellByIndex(cellNumber++).setStringValue(getCellValue(column, rowTramitesExpediente));
				}
			}

			// Se añade el fichero ods al response
			ods.save(response.getOutputStream());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filteredData List<TramitesExpediente>
	 * @param columns      String[]
	 * @param fileName     String
	 * @param sheetTitle   String
	 * @param language     String
	 * @param response     HttpServletResponse
	 */
	private void generateCSVReport(List<TramitesExpediente> filteredData, String[] columns, String[] columnsName,
			String fileName, String sheetTitle, String language, HttpServletResponse response) {
		try {
			// Se añade el fichero excel al response y se añade el contenido
			response.setHeader("Content-Disposition", "attachment; filename=" + fileName + ".csv");
			response.setContentType("text/csv");

			// Separador de campos dependiendo del idioma
			String separator = ";";
			if (language.equals("en")) {
				separator = ",";
			}

			// Se añade el fichero csv al response
			OutputStream out = response.getOutputStream();
			// Añadir titulos
			boolean addTitles = true;

			// Añadir datos
			for (TramitesExpediente rowTramitesExpediente : filteredData) {
				int cellNumber = 1;
				StringBuilder columnsTitles = new StringBuilder();
				StringBuilder row = new StringBuilder();

				// Se iteran las columnas y se insertan los datos respetando el orden que tenian
				// las columnas en la tabla
				for (String column : columns) {
					String cellValue = getCellValue(column, rowTramitesExpediente);

					if (cellNumber < columns.length) {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"");
							columnsTitles.append(separator);
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"");
						row.append(separator);
						cellNumber++;
					} else {
						if (addTitles) {
							columnsTitles.append("\"");
							columnsTitles.append(column);
							columnsTitles.append("\"\n");
						}
						row.append("\"");
						row.append(cellValue);
						row.append("\"\n");
					}
				}

				if (addTitles) {
					out.write(columnsTitles.toString().getBytes());
					addTitles = false;
				}
				out.write(row.toString().getBytes());
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Devuelve los datos recuperados de la DB.
	 *
	 * @param filterTramitesExpediente TramitesExpediente
	 * @param tableRequestDto          TableRequestDto
	 */
	private List<TramitesExpediente> getDataForReports(TramitesExpediente filterTramitesExpediente,
			TableRequestDto tableRequestDto) {
		if (tableRequestDto.getMultiselection().getSelectedAll()
				&& tableRequestDto.getMultiselection().getSelectedIds().isEmpty()) {
			if (filterTramitesExpediente != null) {
				return this.tramitesExpedienteDao.findAllLike(filterTramitesExpediente, tableRequestDto, false);
			} else {
				return this.tramitesExpedienteDao.findAll(new TramitesExpediente(), null);
			}
		} else {
			return this.tramitesExpedienteDao.getMultiple(filterTramitesExpediente, tableRequestDto, false);
		}
	}

	/**
	 * Obtiene los valores de las celdas.
	 *
	 * @param column                String
	 * @param rowTramitesExpediente TramitesExpediente
	 */
	private String getCellValue(String column, TramitesExpediente rowTramitesExpediente) {
		String cellValue = "";
		try {
			cellValue = BeanUtils.getProperty(rowTramitesExpediente, column) != null
					? BeanUtils.getProperty(rowTramitesExpediente, column)
					: "";
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		}

		return cellValue;
	}

	/**
	 * Devuelve la lista de documentos aportados y los no aportados, mirando si
	 * estan siendo ya requeridos para mostrar en la tarea de estudio de
	 * documentacion
	 * 
	 * @throws ParseException
	 * 
	 */
	public HashMap<String, List<DocumentosTarea>> getDocumentListToStudyTask(Expedientes expediente,
			TareasTramite tareasTramite, String estadoTarea) throws ParseException {
		HashMap<String, List<DocumentosTarea>> resultado = new HashMap<String, List<DocumentosTarea>>();

		if (estadoTarea.equalsIgnoreCase(EstadoTareasEnum.ABIERTA.getId())) {
			documentosService.recuperarDocExpedientes(expediente.getIdExpediente00(), resultado);
			return resultado;

		} else {
			HashMap<String, List<DocumentosTarea>> documentos = new HashMap<String, List<DocumentosTarea>>();
			DocumentosTarea docTareaFilter = new DocumentosTarea();
			docTareaFilter.setIdTareaTram18(tareasTramite.getIdTareaTram11());
			docTareaFilter.setEstadoDoc18(EstadoDocuEnum.FINALIZADO.getId());
			// List<Documento> listDocsTareaApor = (List<Documento>)
			// this.documentosTareaService.findAll(docTareaFilter, null);
			List<DocumentosTarea> listDocsTareaApor = new ArrayList<DocumentosTarea>();
			docTareaFilter.setEstadoDoc18(EstadoDocuEnum.PENDIENTE.getId());
			// List<Documento> listDocsTareaFNoApor =
			// this.documentosTareaService.findAll(docTareaFilter, null);
			List<DocumentosTarea> listDocsTareaFNoApor = new ArrayList<DocumentosTarea>();
			// documentos requeridos
//			List<DocumentosRequeridos> listaDocRequeridos = this.docRequeridosServices
//					.findDocRequeridos(expediente.getIdExpediente00());
//			ArrayList<String> listDocReqString = new ArrayList<String>();
//			for (DocumentosRequeridos docReq : listaDocRequeridos) {
//				listDocReqString.add(docReq.getTiposDocumento().getRoleid28());
//			}
//
//			for (int i = 0; i < listDocsTareaApor.size(); i++) {
//				if (listDocReqString.contains(listDocsTareaApor.get(i).getTiposDocumento().getRoleid28())) {
//					listDocsTareaApor.get(i).setRequerido(Constantes.DOCUMENTOS_REQUERIDO);
//				}
//				if (TiposDocumentoRoleEnum.CORRIENTE_OBLIGACIONES_TRIBU.getRoleID()
//						.equals(listDocsTareaApor.get(i).getTiposDocumento().getRoleid28())) {
//					if (expediente.getfConsAtribut36() != null) {
//						try {
//							listDocsTareaApor.get(i)
//									.setInvocationTimestamp(UtilidadesFecha.formatearDateToStringFormatoTime(
//											expediente.getfConsAtribut36(),
//											LocaleContextHolder.getLocale().getLanguage()));
//							listDocsTareaApor.get(i).setInvocationResultIcon(
//									ResultadosIOPEnum.getIcon(com.ejie.ad27b.constantes.Constantes.IOP_OBLIGAT,
//											expediente.getCodResultadoConsAtribut36()));
//						} catch (Exception e) {
//							TramitesExpedienteServiceImpl.logger
//									.debug("Error al parsear la fecga de interoperabilidad");
//						}
//					}
//					listDocsTareaApor.get(i).setInvocationResult(expediente.getResultadoConsAtribut36());
//					listDocsTareaApor.get(i).setCodeInvocationResult(expediente.getCodResultadoConsAtribut36());
//				} else if (TiposDocumentoRoleEnum.CORRIENTE_PAGO_SS.getRoleID()
//						.equals(listDocsTareaApor.get(i).getTiposDocumento().getRoleid28())) {
//					if (expediente.getfConsultaTercero36() != null) {
//						try {
//							listDocsTareaApor.get(i)
//									.setInvocationTimestamp(UtilidadesFecha.formatearDateToStringFormatoTime(
//											expediente.getfConsultaTercero36(),
//											LocaleContextHolder.getLocale().getLanguage()));
//							listDocsTareaApor.get(i)
//									.setInvocationResultIcon(ResultadosIOPEnum.getIcon(
//											com.ejie.ad27b.constantes.Constantes.IOP_OBLIGATSS,
//											expediente.getCodResultadoConsSS36()));
//						} catch (Exception e) {
//							TramitesExpedienteServiceImpl.logger
//									.debug("Error al parsear la fecga de interoperabilidad");
//						}
//					}
//					listDocsTareaApor.get(i).setInvocationResult(expediente.getResultadoConsSS36());
//					listDocsTareaApor.get(i).setCodeInvocationResult(expediente.getCodResultadoConsSS36());
//				}
//			}
//
//			for (int i = 0; i < listDocsTareaFNoApor.size(); i++) {
//				if (listDocReqString.contains(listDocsTareaFNoApor.get(i).getTiposDocumento().getRoleid28())) {
//					listDocsTareaFNoApor.get(i).setRequerido(Constantes.DOCUMENTOS_REQUERIDO);
//				}
//				if (TiposDocumentoRoleEnum.CORRIENTE_OBLIGACIONES_TRIBU.getRoleID()
//						.equals(listDocsTareaFNoApor.get(i).getTiposDocumento().getRoleid28())) {
//					if (expediente.getfConsAtribut36() != null) {
//						try {
//							listDocsTareaFNoApor.get(i)
//									.setInvocationTimestamp(UtilidadesFecha.formatearDateToStringFormatoTime(
//											expediente.getfConsAtribut36(),
//											LocaleContextHolder.getLocale().getLanguage()));
//						} catch (Exception e) {
//							TramitesExpedienteServiceImpl.logger
//									.debug("Error al parsear la fecga de interoperabilidad");
//						}
//					}
//					listDocsTareaFNoApor.get(i).setInvocationResult(expediente.getResultadoConsAtribut36());
//					listDocsTareaFNoApor.get(i).setCodeInvocationResult(expediente.getCodResultadoConsAtribut36());
//				} else if (TiposDocumentoRoleEnum.FICHA_ALTA_TERCEROS.getRoleID()
//						.equals(listDocsTareaFNoApor.get(i).getTiposDocumento().getRoleid28())) {
//					if (expediente.getfConsultaTercero36() != null) {
//						try {
//							listDocsTareaFNoApor.get(i)
//									.setInvocationTimestamp(UtilidadesFecha.formatearDateToStringFormatoTime(
//											expediente.getfConsultaTercero36(),
//											LocaleContextHolder.getLocale().getLanguage()));
//						} catch (Exception e) {
//							TramitesExpedienteServiceImpl.logger
//									.debug("Error al parsear la fecga de interoperabilidad");
//						}
//					}
//					listDocsTareaFNoApor.get(i).setInvocationResult(expediente.getResultadoConsSS36());
//					listDocsTareaFNoApor.get(i).setCodeInvocationResult(expediente.getCodResultadoConsSS36());
//				}
//			}

			documentos.put(Constantes.DOCUMENTOS_APORTADO, listDocsTareaApor);
			documentos.put(Constantes.DOCUMENTOS_NO_APORTADOS, listDocsTareaFNoApor);
			return documentos;
		}
	}

}
